(define (domain blocks)
  (:model (:dynamics :deterministic) (:feedback :complete))
  (:types BLOCK)
  (:functions (on BLOCK BLOCK))
  (:objects table - BLOCK)

  (:predicate (above ?x ?y - BLOCK)
    (:or (= (on ?x) ?y)
         (:exists ?z - BLOCK 
           (:and (= (on ?z) ?y) (above ?x ?z)))))

  (:predicate (clear ?x - BLOCK)
    (:or (= ?x table)
         (:forall ?z - BLOCK (:not (= (on ?z) ?x)))))

  (:action move
    :parameters ?x ?y - BLOCK
    :precondition (:and (clear ?x) (clear ?y)
                        (:not (= ?x table)) (:not (= ?x ?y)))
    :effect (:set (on ?x) ?y)
  )
)

(define (problem p1)
  (:domain blocks)
  (:objects a b c - BLOCK)
  (:init (:set (on a) table)
         (:set (on b) table)
         (:set (on c) b))
  (:goal (:and (= (on b) a) (= (on c) b))))




(define (domain blocks2)
  (:model (:dynamics :deterministic) (:feedback :complete))
  (:types BLOCK)
  (:functions (on BLOCK BLOCK))
  (:objects table - BLOCK)

  (:predicate (above ?x ?y - BLOCK)
    (:or (= (on ?x) ?y)
         (:exists ?z - BLOCK 
            (:and (= (on ?z) ?y) (above ?x ?z)))))

  (:action move
    :parameters ?x ?y - BLOCK
    :precondition (:and (:or (= ?y table)
                             (:forall ?z - BLOCK (:not (above ?z ?y))))
                        (:not (= ?x table)) (:not (= ?x ?y))
                        (:forall ?z - BLOCK (:not (above ?z ?x))))
    :effect (:set (on ?x) ?y)
  )
)

(define (problem p2)
  (:domain blocks2)
  (:objects a b c - BLOCK)
  (:init (:set (on a) table)
         (:set (on b) table)
         (:set (on c) b))
  (:goal (:and (= (on b) a) (= (on c) b))))
