(define (domain tiger)
  (:model (:dynamics :probabilistic) (:feedback :partial))
  (:objects tiger_left dead finished opened_door - :boolean)

  (:action open_left
    :precondition (:and (= dead false) (= finished false))
    :effect (:when (= tiger_left true)  (:set dead true))
            (:when (= tiger_left false) (:set dead false))
            (:set opened_door true)
  )

  (:action open_right
    :precondition (:and (= dead false) (= finished false))
    :effect (:when (= tiger_left true)  (:set dead false))
            (:when (= tiger_left false) (:set dead true))
            (:set opened_door true)
  )

  (:action listen
    :precondition (:and (= dead false) (= finished false))
    :observation (:probabilistic (0.90 (= tiger_left true))
                                 (0.10 (= tiger_left false)))
  )

  (:action fin
    :precondition (:and (= finished false) (= opened_door true))
    :effect (:set finished true)
    :cost (:if (= dead true) 100 1)
  )
)


(define (problem p1)
  (:domain tiger)
  (:init (:set tiger_left :in { true false })
         (:set dead false)
         (:set opened_door false)
         (:set finished false))
  (:goal (= finished true))
)
