(define (domain tiger)
  (:model (:dynamics :probabilistic) (:feedback :partial))
  (:objects tiger_left dead finished opened_door initialized - :boolean)

  (:action open_left
    :precondition (:and (= dead false) (= finished false) (= initialized true))
    :effect (:when (= tiger_left true)  (:set dead true))
            (:when (= tiger_left false) (:set dead false))
            (:set opened_door true)
  )

  (:action open_right
    :precondition (:and (= dead false) (= finished false) (= initialized true))
    :effect (:when (= tiger_left true)  (:set dead false))
            (:when (= tiger_left false) (:set dead true))
            (:set opened_door true)
  )

  (:action listen
    :precondition (:and (= dead false) (= finished false) (= initialized true))
    :observation (:probabilistic (0.90 (= tiger_left true))
                                 (0.10 (= tiger_left false)))
  )

  (:action fin
    :precondition (:and (= finished false) (= opened_door true) (= initialized true))
    :effect (:set finished true)
    :cost (:if (= dead true) 100 1)
  )

  (:action init
    :precondition (= initialized false)
    :effect
      (:probabilistic
         (0.9 (:set tiger_left true)
              (:set initialized true))
         (0.1 (:set tiger_left false)
              (:set initialized true))
      )
  )
)


(define (problem p1)
  (:domain tiger)
  (:init (:set initialized false)
         (:set dead false)
         (:set opened_door false)
         (:set finished false))
  (:goal (= finished true))
)
