//  Theseus
//  theLookAheadHeuristic.h -- Look Ahead Heuristic in Belief Space
//
//  Blai Bonet, Hector Geffner
//  Universidad Simon Bolivar, 1998, 1999, 2000, 2001, 2002

#ifndef _theLookAheadHeuristic_INCLUDE_
#define _theLookAheadHeuristic_INCLUDE_

#include <iostream>

#include <theseus/theHeuristic.h>


class POMDPClass;
class beliefClass;


///////////////////////////////////////////////////////////////////////////////
//
// Look Ahead Heuristic Class
//

class lookAheadHeuristicClass : public heuristicClass
{
  POMDPClass *POMDP;
  heuristicClass *H;
  int lookahead;
  int numActions;
  float discountFactor;

  lookAheadHeuristicClass();

public:
  // constructors/destructors
  lookAheadHeuristicClass( POMDPClass *P, heuristicClass *h );
  virtual ~lookAheadHeuristicClass();

  // methods
  void                             setPOMDP( POMDPClass *P );
  void                             setHeuristic( heuristicClass *h );
  void                             setLookahead( int l );
  int                              getLookahead( void );
  float                            value( int l, const beliefClass *belief );

  // virtual methods
  virtual float                    value( const beliefClass *belief );

  // serialization
  static  void                     checkIn( void );
  virtual void                     write( ostream& os );
  static  lookAheadHeuristicClass* read( istream& is );
  static  lookAheadHeuristicClass* constructor( void );
  static  void                     fill( istream& is, lookAheadHeuristicClass *heuristic );
};


#endif // _theLookAheadHeuristic_INCLUDE
