//  Theseus
//  Main Module
//
//  Blai Bonet, Hector Geffner
//  Universidad Simon Bolivar, 1998, 1999, 2000, 2001


#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include <theseus/theTopLevel.h>


static void
help( void )
{
  cerr << "theseus Revision: " << RTDPrevision << endl;
  cerr << "call arguments:" << endl;
}


int
main( int argc, char **argv )
{
  unsigned long secs, usecs;
  struct timeval t1, t2;

  // register initial time
  gettimeofday( &t1, NULL );

  // parse arguments & initialization
  parseArguments( argc, argv, &help );
  internalInitialization();

  // open outputFile
  if( PD.outputPrefix != NULL )
    {
      PD.outputFilename = new char[strlen( PD.outputPrefix ) + 8];
      sprintf( PD.outputFilename, "%s.output", PD.outputPrefix );
      PD.outputFile = new ofstream( PD.outputFilename, ios::out /*| ios::noreplace*/ );
      if( !(*PD.outputFile) )
	{
	  cerr << PD.outputFilename << ": " << strerror( errno ) << endl;
	  exit( -1 );
	}
    }

  // bootstrap problem
  if( bootstrapProblem() )
    exit( -1 );

  // load core
  if( PD.coreFilename != NULL )
    {
      delete PD.POMDP;
      readCore( PD.coreFilename );
    }

  // print some data
  printParameters( *PD.outputFile, "%call " );
  PD.model->printData( *PD.outputFile );

  // solve problem
  solveProblem();

  // register final time & print elapsed time
  gettimeofday( &t2, NULL );
  diffTime( secs, usecs, t1, t2 );
  *PD.outputFile << "elapsed time = " << (float)secs + ((float)usecs) / 1000000.0 << endl << endl;

  // close outputFile (opened in parseArguments())
  if( PD.outputFile != &cout )
    {
      ((ofstream*)PD.outputFile)->close();
    }

  // exit with no errors
  exit( 0 );
}
