//  Theseus
//  theTriangulation.h -- Freudenthal Triangulation
//
//  Blai Bonet, Hector Geffner
//  Universidad Simon Bolivar, 1998, 1999, 2000, 2001, 2002

#ifndef _theTriangulation_INCLUDE_
#define _theTriangulation_INCLUDE_


///////////////////////////////////////////////////////////////////////////////
//
// Triangulation Class
//

class triangulationClass
{
public:
  // static members
  static int               dimensions;
  static float             levels;
  static beliefCacheClass* cache;

  // constructors
  triangulationClass();

  // destructors
  ~triangulationClass();

  // static methods
  static void initialize( int levels, int dimensions );
  static void setCache( int cacheSize, int clusterSize,
			beliefClass* (*beliefConstructor)( void ) );
  static void finalize( void );

  // methods
  void        clean( void );
  void        triangulate( beliefHashClass* beliefHash, 
			   bool useCache, 
			   const standardBeliefClass* belief, 
			   hashEntryClass**& simplex,
			   map<int,float>*& barycentricCoordinates );
};


#endif // _theTriangulation_INCLUDE
